/*
  RBus2.h - library for R-Bus protocoll on Serial_port_2 
  12/2016 Mitin Alexey

  Version 1.1
  last edition 24.12.16
*/

// ensure this library description is only included once
#define RBus2_h

//CONFIG:
#define XNetVersion 0x36
#define XNetID 0x02	//Zentrale: 0x00 = LZ100; 0x01 = LH200; 0x02 = other

// include types & constants of Wiring core API
#if defined(WIRING)
 #include <Wiring.h>
#elif ARDUINO >= 100
 #include <Arduino.h>
#else
 #include <WProgram.h>
#endif

// when sending data, do NOT continue until the hardware has sent the data out

#define WAIT_FOR_XMIT_COMPLETE_2 {while (!(UCSR2A & (1<<TXC2))); UCSR2A = (1<<TXC2); UCSR2A = 0;}  //17.12.16

//--------------------------------------------------------------------------------------------

// XPressnet Call Bytes.
#define G_B 0x1DE  //  GENERAL_BROADCAST
#define FB_BROADCAST 0x15E

// library interface description
class RBus2Class
{
  // user-accessible "public" interface
  public:
     RBus2Class(void);	//Constuctor
	void setup(uint8_t XControl); //Initialisierung Serial

	void XNetclear0(void);	//Clear a old Message
	void XNetclear1(void);	//Clear a old Message
	// public only for easy access by interrupt handlers
	static inline void handle_interrupt();		//Serial Interrupt bearbeiten
     void XNetsend1(unsigned int databyte);
	void XNetsend(unsigned int *dataString, byte byteCount);	//Sende Datenarray out NOW!
	void getXOR (unsigned int *data, byte length); // calculate the XOR
     bool ReadData;
	byte XNetMsg0[11];	//Serial receive (Length, Header, Data1 to Data7)
	byte XNetMsg1[11];	//Serial receive (Length, Header, Data1 to Data7)
  // library-accessible "private" interface
  private:
     //Variables:
	byte MAX485_CONTROL_2; //Port for send or receive control
	byte XSendCount;	   //Wartezeit bis zum nchsten Device
	byte rxXOR;	        //store the read in XOR

	//Functions:
	void XNetTransmit9 (unsigned int data);
 
};


